/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */


// Pre-calculate some time constants
var msPerSecond = 1000;
var sPerMinute  = 60;
var dPerMonth   = 30.5;
var sPerHour    = 60 * sPerMinute;
var sPerDay     = 24 * sPerHour;


// JavaScript interval timer to update clock
var updateTimerDisplayInterval; 

// Time registers
var passedSeconds;
var remainingTime = new Array(3);
var hoursSaved;
var quitDate;

// Global variables
var NumberOfCiggiesNotSmoked = 0;
var MoneySaved = 0;
var UserCurrency = "NZD";
var pricePer20Packet = 0;
var cigarettesPerDay = 0; 


// Function: updateDisplay()
// The main loop called by the timer interval.
//
function updateDisplay()
{
    getCurrency();
    getUserPrice();
    getUserCiggiesPerDay();
    setQuitDate(event);
    
    calculatePassedTime();
	calculateNonSmokedCiggies();
	calculateMoneySaved();
    calculateTimeSaved();
    formatDisplay();
}

//
// Function: formatDisplay()
// Called by updateDisplay() when the display needs to be updated.
//
function formatDisplay()
{
    setElementText("quit-days",  remainingTime[0] + ' days');
	setElementText("cigarettes-notsmoked",  NumberOfCiggiesNotSmoked);
	setElementText("money-saved",  MoneySaved + " "+ UserCurrency);
    setElementText("time-saved",  hoursSaved + " hours");
}

//
// Function: setElementText(elementName, elementValue)
// Set the text contents of an HTML div
// elementName: Name of the element in the DOM
// elementValue: Text to display in the element
//
function setElementText(elementName, elementValue)
{
    var element = document.getElementById(elementName);
    if (element) {
        element.innerText = elementValue;
    }
}

function getCurrency(event)
{
    var popcurrency = document.getElementById("currency");
	var dropdownIndex = popcurrency.selectedIndex;
    UserCurrency = popcurrency[dropdownIndex].value;    
    widget.setPreferenceForKey(UserCurrency,"currency");
}

function getUserPrice(event)
{ 
    pricePer20Packet = document.getElementById("packetprice").value;    
    widget.setPreferenceForKey(pricePer20Packet,"packetprice");		// and save the new preference to disk
}

function getUserCiggiesPerDay(event) 
{ 
    cigarettesPerDay = document.getElementById("nociggies").value; 
    widget.setPreferenceForKey(cigarettesPerDay,"nociggies");		
}

function getQuitDay(){
    var popQuitDay = document.getElementById("quitDay");
	var dropdownIndex = popQuitDay.selectedIndex;
    var userQuitDay = popQuitDay[dropdownIndex].value;
    widget.setPreferenceForKey(userQuitDay,"quitDay");	
    return userQuitDay;
}

function getQuitMonth(){
    var popQuitMonth = document.getElementById("quitMonth");
	var dropdownIndex = popQuitMonth.selectedIndex;
    var userQuitMonth = popQuitMonth[dropdownIndex].value;
    widget.setPreferenceForKey(userQuitMonth,"quitMonth");
    return userQuitMonth;
 }

function getQuitYear(){
    var popQuitYear = document.getElementById("quitYear");
	var dropdownIndex = popQuitYear.selectedIndex;
    var userQuitYear = popQuitYear[dropdownIndex].value;
    widget.setPreferenceForKey(userQuitYear,"quitYear");
    return userQuitYear;
  }

function setQuitDate(event) {
    var dateString = getQuitMonth() + " " + getQuitDay() + ", " + getQuitYear();  // "Mar 20, 2008"; 
    quitDate = new Date(dateString); 
}


function updateCurrentDate() { currentDate = new Date(); }

// Function: calculatePassedTime()
//
function calculatePassedTime()
{
    // Start by getting the current date
    updateCurrentDate();
    // Clear excessive precision
    currentDate.setMilliseconds(0);

    // Number of seconds between now and source time
    passedSeconds = Math.floor((quitDate.getTime() - currentDate.getTime()) / msPerSecond);
    if (passedSeconds <= 0) {
            passedSeconds = Math.abs(passedSeconds);
        }
    else
            passedSeconds = 0;
        
    // Calculate days
    var passedDays = Math.floor(passedSeconds / sPerDay);
    remainingTime[0] = passedDays;
}

//
// Function: calculateNonSmokedCiggies()
// Determine the number of cigarettes not smoked
//
function calculateNonSmokedCiggies()
{
	var daysNotSmoked = remainingTime[0]
	NumberOfCiggiesNotSmoked = daysNotSmoked * cigarettesPerDay;
}

//
// Function: calculateMoneySaved()
//
function calculateMoneySaved()
{
	MoneySaved = Math.ceil(NumberOfCiggiesNotSmoked * (pricePer20Packet/20));
}

//
// Function: calculateMoneySaved()
//
function calculateTimeSaved()
{
	minutesSaved = Math.ceil(NumberOfCiggiesNotSmoked * 5); //15400
    hoursSaved = Math.floor(minutesSaved/60);
}

//
// Function: setCountdownTarget(countdownEvent)
// Set the timer's current event to count down to

function setCountdownTarget(countdownEvent)
{
    countdownTarget = countdownEvent;
    if (countdownEvent.eventLabel != null) {
        setEventLabel(countdownEvent.eventLabel);
    }
}

//
// Function: startDisplayUpdateTimer()
// Start the interval timer to update the countdown once a second
//
function startDisplayUpdateTimer()
{
    updateDisplay();

    if (!updateTimerDisplayInterval)
        updateTimerDisplayInterval = setInterval(updateDisplay, 1000);
}

//
// Function: stopDisplayUpdateTimer()
// Remove the interval timer
//
function stopDisplayUpdateTimer()
{
    if (updateTimerDisplayInterval) {
        clearInterval(updateTimerDisplayInterval);
        updateTimerDisplayInterval = null;
    }
}


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    
    // get preferences for keys if present
    loadPricePer20Packet();
    loadCigarettesPerDay();
    loadUserCurrency();
    loadQuitDay();
    loadQuitMonth();
    loadQuitYear();
    
    // Get the properties
	setCountdownTarget({eventLabel: null });
}

function loadPricePer20Packet()
{
    // get preference for key if present
    pricePer20Packet = widget.preferenceForKey("packetprice");    
    
    // if the retrieved preferences are not empty,they are restored.
    if (pricePer20Packet && pricePer20Packet.length >0) 
        document.getElementById("packetprice").value = pricePer20Packet;
}    

function loadCigarettesPerDay()
{
    cigarettesPerDay = widget.preferenceForKey("nociggies");
        
    if (cigarettesPerDay && cigarettesPerDay.length >0) 
        document.getElementById("nociggies").value = cigarettesPerDay;
}

function loadUserCurrency()
{
    UserCurrency = widget.preferenceForKey("currency");
        
    if (UserCurrency && UserCurrency.length >0) 
        document.getElementById("currency").value = UserCurrency;
}

function loadQuitDay()
{
    userQuitDay = widget.preferenceForKey("quitDay");
        
    if (userQuitDay && userQuitDay.length >0) 
        document.getElementById("quitDay").value = userQuitDay;
}

function loadQuitMonth()
{
    userQuitMonth = widget.preferenceForKey("quitMonth");
        
    if (userQuitMonth && userQuitMonth.length >0) 
        document.getElementById("quitMonth").value = userQuitMonth;
}

function loadQuitYear()
{
    userQuitYear = widget.preferenceForKey("quitYear");
        
    if (userQuitYear && userQuitYear.length >0) 
        document.getElementById("quitYear").value = userQuitYear;
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    stopDisplayUpdateTimer();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
	// Stop timer to prevent CPU usage
    stopDisplayUpdateTimer();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	// Re-start timer
    startDisplayUpdateTimer();
}


//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";
    
    if (window.widget)
        setTimeout('widget.performTransition();', 0);
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    front.style.display="block";
    back.style.display="none";

    //startDisplayUpdateTimer();
    
    if (window.widget)
        setTimeout('widget.performTransition();', 0);
}

// Initialize the Dashboard event handlers
if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}


function setC(event)
{
    // Insert Code Here
}

